var http = require('http'),
WebSocketServer = require('ws').Server,
port = 1234,
host = '0.0.0.0';
let Listpath=[]; 
// create a new HTTP server to deal with low level connection details (tcp connections, sockets, http handshakes, etc.)
var server = http.createServer();
var listDraw=new Array()
var _ = require('lodash');
// create a WebSocket Server on top of the HTTP server to deal with the WebSocket protocol
var wss = new WebSocketServer({
server: server
});

// create a function to be able do broadcast messages to all WebSocket connected clients
wss.broadcast = function broadcast(message) {
  //console.log("######################################################");
wss.clients.forEach(function each(client) {
  client.send(message);
});
};

// Register a listener for new connections on the WebSocket.
wss.on('connection', function(client, request) {

// retrieve the name in the cookies
var cookies = request.headers.cookie.split(';');
//console.log(cookies)
var wsname = cookies.find((c) => {
  return c.match(/^\s*wsname/) !== null;
});
wsname = wsname.split('=')[1];

// greet the newly connected user
//client.send('Welcome, ' + decodeURIComponent(wsname) + '!');
                                                                                                                                            
// let listClient=[];
// Register a listener on each message of each connection

client.on('message', function(message) {
  var cli = '[' + decodeURIComponent(wsname) + '] ';
  //console.log(listClient.join("|"));
  
  listDraw[cli]=message;
  json = JSON.parse(message);
  var el = {
    clientname: json.name,
    color: json.color,
    points: json.points.slice(1,-1)
  }
  //console.log(json);
  //console.log(el.client);
  var _In = ClientIn(el.clientname, Listpath);
  //console.log(_In)
  //var picked = _.includes(Listpath, el.client);//= _.filter(Listpath, path => path.client === el.client); 
  //console.log(Listpath.length);
  if(_In){
    Listpath.forEach(function each(path) {
      if(el.clientname === path.clientname){
        path.points += ";"+ el.points;
        console.log("#########################################");
      }
    });
  }else{
    Listpath.push(el);
    //console.log("------------------------"+JSON.stringify(el));
  }
   
  //console.log(Listpath);
  
  if(json.points === "[ ]"){
    var list = sendPoints(Listpath,json.name);
    //console.log("+++++++++++++++++++++++++++++++++++++++++++++++++++++++")
    //console.log(list)
    //console.log("+++++++++++++++++++++++++++++++++++++++++++++++++++++++")
    list.forEach(function each(draw) {
      wss.clients.forEach(function each(client) {
        client.send(JSON.stringify(draw));
      });
    });
  }else{
    wss.broadcast(listDraw[cli])
  }
  


});
});




// http sever starts listening on given host and port.
server.listen(port, host, function() {
console.log('Listening on ' + server.address().address + ':' + server.address().port);
});

process.on('SIGINT', function() {
process.exit(0);
});

function ClientIn(name, Listpath) {
  for(var i = 0; i < Listpath.length; i++) {
      if (Listpath[i].clientname == name) {
          return true;       
      }
  }
}

function sendPoints(listPoint,clientname) {
  var path ;
  for(var i = 0; i < listPoint.length; i++) {
    if (listPoint[i].clientname == clientname) {
        path = listPoint[i];
        //console.log(path.points);     
    }
  }
  var client = clientname; 
  var colorpixel = path.color; 
  var x_y= path.points.split(";");
  //console.log(x_y);
  var listPixel= [];
  for(var i = 0; i < x_y.length; i++) {
    var pixel = {
      name:client,
      color:colorpixel,
      points:"["+x_y[i]+"]"
    }
    listPixel.push(pixel);
}
  return listPixel;
    
}

